/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Connection Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <string.h>

#include <ostore/ostore.hh>
#include <ostore/coll.hh>
#include <ostore/relat.hh>
#include "OO7.h"
#include "GenParams.h"

extern os_database* oo7db;

extern int	debugMode;
extern char*	types[NumTypes];

////////////////////////////////////////////////////////////////////////////
//
// Connection Constructor
//
////////////////////////////////////////////////////////////////////////////

Connection::Connection(AtomicPart* fromPart, AtomicPart* toPart)
{
    if (debugMode) {
        printf("BEGIN Connection::Connection(fromId = %d, toId = %d)\n",
            fromPart->id, toPart->id);
    }

    // initialize internal state of new connection (some of it randomly)

    int typeNo = (int) (random() % NumTypes);
    strncpy(type, types[typeNo], TypeSize);
    length = (int) (random() % XYRange);
    from = fromPart;
    to = toPart;

    if (debugMode) {
        printf("END Connection::Connection(fromId = %d, toId = %d)\n",
            fromPart->id, toPart->id);
    }
}

