/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


#include <libc.h>
#include <string.h>
#include <stdio.h>

#include <ostore/ostore.hh>
#include <ostore/coll.hh>
#include <ostore/relat.hh>
#include "OO7.h"
#include "GenParams.h"
#include "BenchParams.h"
#include "VarParams.h"

//////////////////////////////////////////////////////////////////
//
// Query #8 --- value join between Documents and AtomicParts
// on Document.id and AtomicPart.docId.  This is a key - foreign
// key join.
//
// The main drawback is that we have no semantics whatsoever for
// this query.
//
//////////////////////////////////////////////////////////////////

extern os_database* oo7db;

extern int	debugMode;

extern void JoinDoNothing(int x, int y);


//////////////////////////////////////////////////////////////////
//
// Routine to do Query #8
//
//////////////////////////////////////////////////////////////////


int query8()
{
    int count = 0;

//  foreach (AtomicPart* ap, *AtomicPart::extent, os_cursor::sorted_iteration) {

    AtomicPart* ap;
    os_cursor c(*AtomicPart::extent, os_cursor::sorted_iteration);
    for (ap = (AtomicPart*)c.first(); ap; ap = (AtomicPart*)c.next()) {

        if (debugMode) {
            printf("    In Query8, processing atomic part %d.\n", ap->id);
        }

	os_Set<Document*>& docSet = (*Document::extent)[: id == ap->docId :];
        foreach (Document* doc, docSet) {

	    if (debugMode) {
                printf("In Query8, atomic part %d matches doc %d.\n",
	                ap->id, doc->id);
            }

            JoinDoNothing(ap->id, doc->id);
	    count++;
        }
    }

    return count;
}

